#version 100
#extension GL_OES_EGL_image_external : require

precision mediump float;

varying vec2 vTexCoord;

#if defined (EXTERNAL_OES_VIDEO_TEXTURE)
uniform samplerExternalOES sVideoTexture;
#elif defined (TEXTURE_2D_VIDEO_TEXTURE)
uniform sampler2D sVideoTexture;
#endif

// Normalized radius of the circular video
uniform float uNormalizedRadius;
// Blur the edge of the circle boarder to give anti-aliasing effect
// This value determines how far the edge is blurred
uniform float uAntiAliasingFactor;

// Solid white boarder
vec4 white = vec4(1.0);
// Center the circle at the center of the canvas
vec2 circleCenter = vec2(0.5, 0.5);

float antiAliasingRadius;
float alpha;
float dist;


void main() {
    
    antiAliasingRadius = uNormalizedRadius - uAntiAliasingFactor;
    dist = length(vTexCoord - circleCenter);
    alpha = smoothstep(antiAliasingRadius, uNormalizedRadius, dist);
    gl_FragColor = texture2D(sVideoTexture, vTexCoord);

    gl_FragColor = mix(white, gl_FragColor, 1.0 - alpha);
}