attribute vec4 a_Position;

// because this one is shared with fragment shader
#ifdef GL_FRAGMENT_PRECISION_HIGH
uniform vec2 u_Resolution;
#else
uniform mediump vec2 u_Resolution;
#endif

uniform vec2 u_TextureSize;

varying vec2 v_TexCoordinate;
varying vec2 v_CircleCoordinate;

void main() {
    gl_Position = a_Position;
    vec2 texCoord = (gl_Position.xy + 1.0) / 2.0;
    v_TexCoordinate = vec2(texCoord.x, 1.0 - texCoord.y);

    float ar = (u_Resolution.x / u_Resolution.y) / (u_TextureSize.x / u_TextureSize.y);
    float iar = 1.0 / ar;
    vec2 scale = vec2(min(ar, 1.0), min(iar, 1.0));
    v_TexCoordinate *= scale;
    v_TexCoordinate += (vec2(1.0) - scale) / 2.0;

    // unit is screen pixel, (0,0) at top left
    v_CircleCoordinate = (a_Position.xy * vec2(1.0, -1.0) + 1.0) / 2.0 * u_Resolution;
}
